Loading...
Searching...
No Matches
Gudhi::rips_complex::SimplicialComplexForRips Struct Reference

The concept SimplicialComplexForRips describes the requirements for a type to implement a simplicial complex, that can be created from a Rips_complex. The only available model for the moment is the Simplex_tree. More...

`#include <concept/Rips_complex/SimplicialComplexForRips.h>`

## Public Types

typedef unspecified | Filtration_value
| Type used to store the filtration values of the simplicial complex.
typedef unspecified | Simplex_handle
| Handle type to a simplex contained in the simplicial complex.

## Public Member Functions

template<class OneSkeletonGraph>
void | insert_graph (const OneSkeletonGraph &skel_graph)
| Inserts a given Gudhi::rips_complex::Rips_complex::OneSkeletonGraph in the simplicial complex.
void | expansion (int max_dim)
| Expands the simplicial complex containing only its one skeleton until a given maximal dimension as explained in Rips complex definition.
template<typename Blocker>
void | expansion_with_blockers (int max_dim, Blocker block_simplex)
| Expands a simplicial complex containing only a graph. Simplices corresponding to cliques in the graph are added incrementally, faces before cofaces, unless the simplex has dimension larger than max_dim or block_simplex returns true for this simplex.
unspecified | simplex_vertex_range (Simplex_handle sh)
| Returns a range over the vertices of a simplex.
std::size_t | num_vertices ()
| Returns the number of vertices in the simplicial complex.

## Detailed Description

The concept SimplicialComplexForRips describes the requirements for a type to implement a simplicial complex, that can be created from a Rips_complex. The only available model for the moment is the Simplex_tree.

## Member Function Documentation

## expansion_with_blockers()

template<typename Blocker>

void Gudhi::rips_complex::SimplicialComplexForRips::expansion_with_blockers | ( | int | max_dim,
|  | Blocker | block_simplex )

Expands a simplicial complex containing only a graph. Simplices corresponding to cliques in the graph are added incrementally, faces before cofaces, unless the simplex has dimension larger than max_dim or block_simplex returns true for this simplex.

Parameters

  [in] | max_dim | Expansion maximal dimension value.
  [in] | block_simplex | Blocker oracle. Its concept is `bool block_simplex(Simplex_handle sh)`

The function identifies a candidate simplex whose faces are all already in the complex, inserts it with a filtration value corresponding to the maximum of the filtration values of the faces, then calls block_simplex on a Simplex_handle for this new simplex. If block_simplex returns true, the simplex is removed, otherwise it is kept.

The documentation for this struct was generated from the following file:

- concept/Rips_complex/SimplicialComplexForRips.h